#include <Servo.h>
#include <SoftwareSerial.h>
#include <DFRobotDFPlayerMini.h>

// Create instances of Servo and SoftwareSerial objects
Servo myservo;
SoftwareSerial mySoftwareSerial(10, 11); // RX, TX for DFPlayer

// Initialize DFPlayer object
DFRobotDFPlayerMini myDFPlayer;

// Define pin for servo
int servoPin = 9;
// Define pin for Microphone
int sensorPin =7;
int val;
int counter=0;
unsigned long previousMillis=0;

void setup() {
  // Initialize servo and DFPlayer
  
  mySoftwareSerial.begin(9600);
  Serial.begin(115200);
  Serial.println("Initializing DFPlayer...");

  if (!myDFPlayer.begin(mySoftwareSerial)) {  // Use softwareSerial to communicate with DFPlayer
    Serial.println(F("Unable to begin DFPlayer."));
    Serial.println(F("1.Please check SD card."));
    Serial.println(F("2.Please check MP3 files."));
    while (true) {
      delay(0); // Code should never reach this line, but just in case
    }
  }
  Serial.println(F("DFPlayer Mini online."));
  myDFPlayer.volume(25);  // Set volume value. From 0 to 30
  
}
void loop()
 {
  // Check if the DFPlayer is still playing
   val =digitalRead(sensorPin);
   Serial.println(val);
unsigned long currentMillis=millis();
if(currentMillis -previousMillis>=30000)
{
  if (myDFPlayer.readState() == 512){

previousMillis=currentMillis;
myDFPlayer.play(3);
  }
}

if (val == 1)
{
  if(counter==0)
  {
  delay(2000);
  myDFPlayer.play(1);
 counter=counter+1;
 previousMillis=millis();
  }
  else if (counter==1)
  {
    delay(2000);
  myDFPlayer.play(2);
 counter=0;
  previousMillis=millis();
  }
}


  while (myDFPlayer.readState() == 513) { // Playing state
    // Move the servo to two positions
    myservo.attach(servoPin);
    myservo.write(45);  // Move servo to 0 degrees
    delay(100);  // Wait for half a second
    myservo.write(60);  // Move servo to 45 degrees
    delay(100);  // Wait for half a second
  }
  if (myDFPlayer.readState() == 512){
    myservo.write(45);
    delay(500);
    myservo.detach();

  }
}